#ifdef SSL
#include "anircd.h"

SSL_CTX *g_SSLctx = NULL;
static int g_SSLinit = 0;

int init_SSL(char *key_file)
{
	SSL_METHOD	*meth;
	SSL_CTX		*ctx;

	if (!g_SSLinit)
	{
		SSL_library_init();
		SSL_load_error_strings();
		g_SSLinit = 1;
	}

	meth = SSLv23_method();
	ctx = SSL_CTX_new(meth);

	if (!SSL_CTX_use_certificate_chain_file(ctx, key_file) || !SSL_CTX_use_PrivateKey_file(ctx, key_file, SSL_FILETYPE_PEM))
	{
		log_error("Failed to load SSL cert / private key from %s", key_file);
		return(0);
	}

	SSL_CTX_set_verify(ctx, SSL_VERIFY_NONE, NULL);
	SSL_CTX_set_mode(ctx, SSL_MODE_ENABLE_PARTIAL_WRITE);

	g_SSLctx = ctx;

	return(1);
}
#endif
